BUOI3/Controllers/HomeController.cs
using BUOI3.Models;
using BUOI3.Repositories;
using Microsoft.AspNetCore.Mvc;
using System.Diagnostics;

namespace BUOI3.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

       
        private readonly IProductRepository _productRepository;
        public HomeController(IProductRepository productRepository) 
        {
            _productRepository = productRepository;
        }
        //hien thi danh sach san pham
        public async Task<IActionResult> Index()
        {
            var products = await _productRepository.GetAllAsync();
            return View(products);
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

BUOI3/Controllers/ShoppingCartController.cs
using BUOI3.Data;
using BUOI3.Models;
using BUOI3.Repositories;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;

namespace BUOI3.Controllers
{
    [Authorize]
    public class ShoppingCartController : Controller
    {
        private readonly IProductRepository _productRepository;
        private readonly ApplicationDbContext _context;
        private readonly UserManager<ApplicationUser> _userManager;
        public ShoppingCartController(ApplicationDbContext context,UserManager<ApplicationUser> userManager,IProductRepository productRepository)
        {
            _productRepository = productRepository;
            _context = context;
            _userManager = userManager;
          
        }
        public IActionResult CheckOut()
        {
            return View(new Order());
        }
        [HttpPost]
        public async Task<IActionResult> Checkout(Order order)
        {
            var cart = HttpContext.Session.GetObjectFromJson<ShoppingCart>("Cart");
            if (cart == null || !cart.Items.Any())
            {
                //xu ly gio hang trong
                return RedirectToAction("Index");
            }
            var user = await _userManager.GetUserAsync(User);
            order.UserId = user.Id;
            order.OrderDate= DateTime.UtcNow;
            order.TotalPrice = cart.Items.Sum(i => i.Price * i.Quantity);
            order.OrderDetails=cart.Items.Select(i=>new OrderDetail
            {
                ProductId=i.ProductId,
                Quantity=i.Quantity,
                Price=i.Price
            }).ToList();
            _context.Orders.Add(order);
            await _context.SaveChangesAsync();
            HttpContext.Session.Remove("Cart");
            return View("OrderComplete", order.Id);//trang xac nhan hoan thanh don hang
        }
        public async Task<IActionResult> AddToCart(int productId, int quantity)
        {
            // gia su ban lay thong tin san pham tu ProductId
            var product = await GetProductFromDatabase(productId);

            var cartItem = new CartItem
            {
                ProductId = productId,
                Name = product.Name,
                Price = product.Price,
                Quantity = quantity
            };
            var cart = HttpContext.Session.GetObjectFromJson<ShoppingCart>("Cart") ?? new ShoppingCart();
            cart.AddItem(cartItem);
            HttpContext.Session.SetObjectAsJson("Cart", cart);
            return RedirectToAction("Index");
        }
        public IActionResult Index()
        {
            var cart = HttpContext.Session.GetObjectFromJson<ShoppingCart>("Cart")??new ShoppingCart();

            return View(cart);
        }
        private async Task<Product> GetProductFromDatabase(int productId)
        {
            //truy van co so du lieu de lay thong tin san pham
            var product = await _productRepository.GetByIdAsync(productId);
            return product;
        }
        public IActionResult RemoveFromCart(int productId)
        {
            var cart = HttpContext.Session.GetObjectFromJson<ShoppingCart>("Cart");
            if(cart is not null)
            {
                cart.RemoveItem(productId);
                //luu laij gio hang vao sesson sau khi da xoa muc
                HttpContext.Session.SetObjectAsJson("Cart", cart);
            }
            return RedirectToAction("Index");
        }
    }
}

BUOI3/Views/Home/Index.cshtml
@model IEnumerable<BUOI3.Models.Product>

@{
    ViewData["Title"] = "Home Page";
    int numOfQuantity = 1;
}
<section class="py-2">
    <div class="container px-4 px-lg-5 mt-5">
        <div class="row gx-4 gx-lg-5 row-cols-2 row-cols-md-3 row-cols-xl-4 justify-content-center">
            @foreach(var item in Model)
            {
                <div class="col mb-5">
                    <div class="card gap-3" style="width:18rem;">
                        <img src="@item.ImageUrl" class="card-img-top" alt="..." style="height:300px;">
                        <div class="card-body">
                            <h5 class="card-title">@Html.DisplayFor(modelItem=>item.Name)</h5>
                            <div class="d-flex">
                                <span>Price: </span>
                                <p class="mx-3">@item.Price.ToString("#,##0") Vnđ</p>
                            </div>
                            <a asp-controller="ShoppingCart" asp-action="AddToCart" asp-route-productId="@item.Id" asp-route-quantity="@numOfQuantity"><button class="btn btn-outline-dark"><i class="bi-cart-fill me-1"></i>Add to Cart</button></a>
                        </div>
                    </div>
                </div>
            }
        </div>
    </div>
</section>